Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# DefaultEncryptorWithMAC Class Reference

`#include <default.h>`

Inheritance diagram for DefaultEncryptorWithMAC:

List of all members.

## Detailed Description

Password-Based Encryptor using DES-EDE2 and HMAC/SHA-1.

Definition at line 66 of file default.h.

## SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transfered signals
virtual int | GetAutoSignalPropagation () const
## Public Member Functions
| DefaultEncryptorWithMAC (const char *passphrase, BufferedTransformation *attachment=NULL)
| DefaultEncryptorWithMAC (const byte *passphrase, unsigned int passphraseLength, BufferedTransformation *attachment=NULL)
void | IsolatedFlush (bool completeFlush)
bool | IsolatedFlush (bool hardFlush, bool blocking)
void | SetFilter (Filter *filter)
void | NextPutMultiple (const byte *s, unsigned int len)
void | IsolatedInitialize (const NameValuePairs &parameters)
unsigned int | Put2 (const byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
unsigned int | PutModifiable2 (byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes that may be modified by callee for blocking or non-blocking processing
void | ForceNextPut ()
bool | Attachable ()
| returns whether this object allows attachment
BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
const BufferedTransformation * | AttachedTransformation () const
void | Detach (BufferedTransformation *newAttachment=NULL)
| delete the current attachment chain and replace it with newAttachment
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
void | FirstPut (const byte *inString)
void | LastPut (const byte *inString, unsigned int length)
bool | DidFirstPut ()
virtual void | InitializeDerivedAndReturnNewSizes (const NameValuePairs &parameters, unsigned int &firstSize, unsigned int &blockSize, unsigned int &lastSize)
virtual void | InitializeDerived (const NameValuePairs &parameters)
virtual void | NextPutSingle (const byte *inString)
virtual void | NextPutModifiable (byte *inString, unsigned int length)
virtual void | FlushDerived ()
virtual void | NotifyAttachmentChange ()
virtual BufferedTransformation * | NewDefaultAttachment () const
void | Insert (Filter *nextFilter)
virtual bool | ShouldPropagateMessageEnd () const
virtual bool | ShouldPropagateMessageSeriesEnd () const
void | PropagateInitialize (const NameValuePairs &parameters, int propagation, const std::string &channel=NULL_CHANNEL)
unsigned int | Output (int outputSite, const byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputFlush (int outputSite, bool hardFlush, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageSeriesEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Protected Attributes
member_ptr< BufferedTransformation > | m_filter
OutputProxy * | m_proxy
unsigned int | m_inputPosition
int | m_continueAt

## Member Function Documentation

bool FilterWithBufferedInput::IsolatedFlush | ( | bool | hardFlush,
|  | bool | blocking
| ) | `[virtual, inherited]`

| calls ForceNextPut() if hardFlush is true Implements BufferedTransformation. Definition at line 244 of file filters.cpp. References FilterWithBufferedInput::ForceNextPut().

unsigned int FilterWithBufferedInput::Put2 | ( | const byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Implements BufferedTransformation. Definition at line 136 of file filters.h.

unsigned int FilterWithBufferedInput::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented from BufferedTransformation. Definition at line 140 of file filters.h.

void FilterWithBufferedInput::ForceNextPut | ( |  | ) | `[inherited]`

| the input buffer may contain more than blockSize bytes if lastSize != 0 ForceNextPut() forces a call to NextPut() if this is the case Definition at line 346 of file filters.cpp. Referenced by FilterWithBufferedInput::IsolatedFlush().

bool Filter::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented from BufferedTransformation. Definition at line 19 of file filters.h.

bool Filter::Flush | ( | bool | hardFlush,
|  | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented from BufferedTransformation. Reimplemented in SecretSharing, and InformationDispersal. Definition at line 70 of file filters.cpp.

bool Filter::MessageSeriesEnd | ( | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented from BufferedTransformation. Definition at line 84 of file filters.cpp.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 702 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

  | request space to write bytes into for processing Parameters:
  size | is requested size (as a hint) for input, and size of the returned space for output
Reimplemented in HashFilter, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 720 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transfered signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 778 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 229 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 318 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- default.h
- default.cpp